'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _betterPromise = require('better-promise');

var _betterPromise2 = _interopRequireDefault(_betterPromise);

var _router = require('./router');

var _router2 = _interopRequireDefault(_router);

var _store = require('./store');

var _store2 = _interopRequireDefault(_store);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var createDeferred = function createDeferred() {
  var deferred = {};
  deferred.promise = new _betterPromise2.default(function (resolve, reject) {
    deferred.resolve = resolve;
    deferred.reject = reject;
  });
  return deferred;
};

var Batcher = function () {
  function Batcher() {
    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var _ref$delay = _ref.delay;
    var delay = _ref$delay === undefined ? 0 : _ref$delay;
    var _ref$router = _ref.router;
    var router = _ref$router === undefined ? new _router2.default() : _ref$router;
    var _ref$store = _ref.store;
    var store = _ref$store === undefined ? new _store2.default() : _ref$store;

    _classCallCheck(this, Batcher);

    this.delay = delay;
    this.router = router;
    this.store = store;
  }

  _createClass(Batcher, [{
    key: 'run',
    value: function run(_ref2) {
      var force = _ref2.force;
      var query = _ref2.query;

      if (!this.delay) return this.router.run({ force: force, query: query, store: this.store });

      if (!this.batch) {
        this.batch = {
          deferred: createDeferred(),
          force: [[]],
          query: [[]],
          timeoutId: setTimeout(this.flush.bind(this), this.delay)
        };
      }

      this.batch.query[0].push(query);
      if (force) this.batch.force[0].push(force === true ? query : force);
      return this.batch.deferred.promise;
    }
  }, {
    key: 'flush',
    value: function flush() {
      var _batch = this.batch;
      var _batch$deferred = _batch.deferred;
      var resolve = _batch$deferred.resolve;
      var reject = _batch$deferred.reject;
      var force = _batch.force;
      var query = _batch.query;
      var store = this.store;

      delete this.batch;
      this.router.run({ force: force, query: query, store: store }).then(resolve, reject);
    }
  }, {
    key: 'destroy',
    value: function destroy() {
      if (this.batch) clearTimeout(this.batch.timeoutId);
    }
  }]);

  return Batcher;
}();

exports.default = Batcher;
