'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _pathKeyToRouteQueryKey = require('./path-key-to-route-query-key');

var _pathKeyToRouteQueryKey2 = _interopRequireDefault(_pathKeyToRouteQueryKey);

var _pathToRoute = require('./path-to-route');

var _pathToRoute2 = _interopRequireDefault(_pathToRoute);

var _queryToPaths = require('./query-to-paths');

var _queryToPaths2 = _interopRequireDefault(_queryToPaths);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (routes, path) {
  var query = [];
  for (var i = 0, l = path.length; i < l; ++i) {
    query[i] = (0, _pathKeyToRouteQueryKey2.default)(path[i]);
  }

  for (var _i = query.length; _i > 0; --_i) {
    var paths = (0, _queryToPaths2.default)(query.slice(0, _i));
    for (var j = 0, _l = paths.length; j < _l; ++j) {
      var route = (0, _pathToRoute2.default)(paths[j]);
      var fn = routes[route];
      if (fn) return { route: route, fn: fn };
    }
  }

  throw new Error('No route matches ' + JSON.stringify(path));
};
